class TIMER1
{
   public:
     TIMER1()
     {
     }
     
     void start()
     {
        //Timer1, Mode 14 WGM13..0 1110
        //Vorteilung 1, CS12..0  001 
        TCCR1B = (1<<WGM13) | (1<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10) ;
        TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (1<<WGM11) | (0<<WGM10);
        //TOP=ICR1=3199
        //N=1
        //fpwm = fclock / ( N*(1+TOP) ) = 16000000/3200==5000Hz    
    
        ICR1 = MOTORMAX;
  
        DDRB |= (1<<PB5);  //ist D9 / OC1A
    
        //ISR aufgrund Überlauf Timer 1:
        TIMSK1 |= (1<<OCIE1A);  
        //TIMSK1 |= (1<<ICIE1);  //Match mit ICR1
    
        //Interrupts aktivieren
        sei();            
     }
} timer1;

class ADW
{
    public:
        long int sensor=0;
        unsigned int akku, akku2;
    
        ADW()
        {
        }

        void start()
        {
            //A0 ist ADC7 auf dem Arduino Micro:
            //MUX:000111
  
            //Vorteilung bei 16Mhz soll 60kHz ergeben, deshalb: 16000000/60000 = 266,67
            //Nächster Wert: 256, also 16000000/256 = 62500Hz (o.k.)
  
            //ADLAR==1 => oberen 8 Bit komplett in ADCH, unteren 2 in oberen von ADCL
            //ADEN==1 aktiv
            //ADSC==1 start conversion / start 1st bei free running
            //ADTS3..0 ==0 free running mode
    
            //REFS1..0 00==VREF intern , extern ausgeschaltet
            //ADHSM 1==High speed , mehr Stromverbrauch
    
            //ADTS3..0    Koppeln an Timer 1 Overflow: 0110
            ADCSRA = (1<<ADEN) | (1<<ADSC) | (0<<ADATE) | (0<<ADIF) | (0<<ADIE) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);  
            ADCSRB = (1<<ADHSM) | (0<<ACME) | (0<<MUX5) | (0<<ADTS3) | (1<<ADTS2) | (1<<ADTS1) | (0<<ADTS0);
            ADMUX = (1<<REFS1) | (0<<REFS0) | (1<<ADLAR) | (0<<MUX4) | (0<<MUX3) | (1<<MUX2) | (1<<MUX1) | (1<<MUX0);                      
        }
        
        void aktualisieren()
        {
            akku2 = ADCL; //muss erst ausgelesen werden, damit ADCL verfügbar ist
            akku  = ADCH;
            ADCSRA |= (1<<ADSC);  //Neue Wandlung anfordern, ist (hoffentlich) fertig bei nächstem Durchlauf    
            sensor = (akku<<2) | (akku2>>6);            
            //sensor-=608;          
        }
        
        long int holeWert()
        {
            return sensor;
        }
} adw;


